"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const schematics_1 = require("@angular-devkit/schematics");
const core_1 = require("@angular-devkit/core");
const project_1 = require("../utils/project");
const parse_name_1 = require("@schematics/angular/utility/parse-name");
function sandbox(options) {
    return (host, context) => {
        if (options.path === undefined) {
            options.path = project_1.getProjectPath(host, options);
        }
        const parsedPath = parse_name_1.parseName(options.path, options.name);
        options.name = parsedPath.name;
        options.path = parsedPath.path;
        const targetPath = options.flat
            ? options.path
            : `${options.path}/${options.name}`;
        const prefix = project_1.getProject(host, {}).prefix;
        const selector = `${prefix}-${options.name}`;
        const templateSource = schematics_1.apply(schematics_1.url('./files'), [
            schematics_1.template(Object.assign({}, core_1.strings, { selector }, options)),
            schematics_1.move(targetPath),
        ]);
        return schematics_1.chain([
            schematics_1.branchAndMerge(schematics_1.mergeWith(templateSource))
        ])(host, context);
    };
}
exports.default = sandbox;
//# sourceMappingURL=index.js.map